unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes,
  SysUtils,
  FileUtil,
  Forms,
  Controls,
  Graphics,
  Dialogs,
  ExtCtrls,
  StdCtrls,
  PrintersDlgs,
  Printers;

type

  { TMainForm }

  TMainForm     = class(TForm)
    Image       : TImage;
    Print       : TButton;
    Panel       : TPanel;
    PrintDialog : TPrintDialog;
    RadioGroup  : TRadioGroup;
    procedure     FormCreate(Sender: TObject);
    procedure     FormResize(Sender: TObject);
    procedure     PrintClick(Sender: TObject);
    procedure     RadioGroupClick(Sender: TObject);
  private
    procedure     PaintPieOrEllipse(c : tCanvas; w, h : Integer);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.lfm}

{ TMainForm }

procedure TMainForm.FormCreate(Sender: TObject);
  begin
    Image.align := alClient;
  end;

procedure TMainForm.FormResize(Sender: TObject);
  begin
    Image.Picture.Bitmap.Height := Image.Height;
    Image.Picture.Bitmap.Width  := Image.Width;
    Image.Picture.Bitmap.Canvas.Brush.Color := clWhite;
    Image.Picture.Bitmap.Canvas.FillRect(0, 0, Image.Picture.Bitmap.Width,
                                               Image.Picture.Bitmap.Height);
    PaintPieOrEllipse(Image.Picture.Bitmap.Canvas,
                      Image.Picture.Bitmap.Width,
                      Image.Picture.Bitmap.Height);
  end;

procedure TMainForm.PrintClick(Sender: TObject);
  begin
    if PrintDialog.Execute then
      begin
        Printer.Title := 'Pie';
        Printer.BeginDoc;
        PaintPieOrEllipse(Printer.Canvas,
                          Printer.PageWidth,
                          Printer.PageHeight);
        Printer.EndDoc;
      end;
  end;

procedure TMainForm.RadioGroupClick(Sender: TObject);
  begin
    Image.Picture.Bitmap.Canvas.FillRect(0, 0, Image.Picture.Bitmap.Width,
                                               Image.Picture.Bitmap.Height);
    PaintPieOrEllipse(Image.Picture.Bitmap.Canvas,
                      Image.Picture.Bitmap.Width,
                      Image.Picture.Bitmap.Height);
  end;

procedure TMainForm.PaintPieOrEllipse(c : tCanvas; w, h : Integer);
  begin
    if RadioGroup.ItemIndex = 0 then
      c.Pie(0, 0, w - 1, h - 1, 0, h - 1, 0, 0)
    else
      c.Ellipse(0, 0, w - 1, h - 1);
  end;

end.

